unit Listmain;
{added to propexp.dpr added 30/11/95 BI}
{checked 24/05/2000 BI}
interface

uses
  Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls;

type
  TFrmListMaint = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    GroupList: TGroupBox;
    SrcList: TListBox;
    RGAvailLists: TRadioGroup;
    procedure IncludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure MoveSelected(List: TCustomListBox);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    procedure RGAvailListsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    function execute : boolean;
  end;

var
  FrmListMaint: TFrmListMaint;

implementation
uses
  propform;

const
  CClassName = 0;
  CPropertyName = 1;
  CDataType = 2;
  CPrivateVar = 3;
  CArrayIndex = 4;
  CDefault = 5;
  CIndex = 6;
  CStoredExp = 7;

{$R *.DFM}

function TFrmListMaint.execute : boolean;
Var
   lc, mc : integer;

begin
   showmodal;
   result := (modalresult = mrOK);
   if result then begin
{    for lc := CClassName to CStoredExp do begin}
     case RGAvailLists.itemindex of
          CClassName : PropExpert.ClassName.items := SrcList.items;
       CPropertyName : PropExpert.PropertyName.items := SrcList.items;
           CDataType : PropExpert.DataType.items := SrcList.items;
         CPrivateVar : PropExpert.PrivateVar.items := SrcList.items;
         CArrayIndex : PropExpert.ArrayIndex.items := SrcList.items;
            CDefault : PropExpert.DefaultC.items := SrcList.items;
              CIndex : PropExpert.IndexEdit.items := SrcList.items;
          CStoredExp : PropExpert.StoredExp.items := SrcList.items;
     end;
{    end;}
   end;
end;

procedure TFrmListMaint.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList);
  SetItem(SrcList, Index);
end;

procedure TFrmListMaint.IncAllBtnClick(Sender: TObject);

begin
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TFrmListMaint.MoveSelected(List: TCustomListBox);
Var
   lc, mc : integer;
begin
   mc := pred(List.Items.Count);
   for lc :=  mc downto 0 do begin
    if List.Selected[lc] then List.Items.Delete(lc);
   end;
end;

procedure TFrmListMaint.SetButtons;
var
  SrcEmpty : Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
end;

function TFrmListMaint.GetFirstSelection(List: TCustomListBox): Integer;
Var
   mc : integer;

begin
   mc := pred(List.Items.count);
   for Result := 0 to mc do begin
      if List.Selected[Result] then Exit;
   end;
   Result := LB_ERR;
end;

procedure TFrmListMaint.SetItem(List: TListBox; Index: Integer);
Var
   lc, mc : integer;
begin
  with List do
  begin
    SetFocus;
    Mc := pred(List.Items.Count);
    if Index = LB_ERR then Index := 0
    else if Index > Mc then Index := Mc;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TFrmListMaint.RGAvailListsClick(Sender: TObject);
begin
  case RGAvailLists.itemindex of
     CClassName : SrcList.items := PropExpert.ClassName.items;
  CPropertyName : SrcList.items := PropExpert.PropertyName.items;
      CDataType : SrcList.items := PropExpert.DataType.items;
    CPrivateVar : SrcList.items := PropExpert.PrivateVar.items;
    CArrayIndex : SrcList.items := PropExpert.ArrayIndex.items;
       CDefault : SrcList.items := PropExpert.DefaultC.items;
         CIndex : SrcList.items := PropExpert.IndexEdit.items;
     CStoredExp : SrcList.items := PropExpert.StoredExp.items;
  end;
  GroupList.caption := ' '+RGAvailLists.items[RGAvailLists.itemindex]+' ';
  SetButtons;
end;

procedure TFrmListMaint.FormActivate(Sender: TObject);
begin
   RGAvailLists.itemindex := 0;
end;

end.

