unit Propform;
{checked 24/05/2000 BI}

interface

uses
  SysUtils, Windows, Classes, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, clipbrd, menus,
  cybifile, cybmanip;

type
  TPropExpert = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ArrayIndex: TComboBox;
    DefaultC: TComboBox;
    IndexEdit: TComboBox;
    OKBtn: TBitBtn;
    Label9: TLabel;
    RGRead: TRadioGroup;
    RGWrite: TRadioGroup;
    ClassName: TComboBox;
    PropertyName: TComboBox;
    DataType: TComboBox;
    PrivateVar: TComboBox;
    CancelBtn: TBitBtn;
    ListBtn: TBitBtn;
    Label13: TLabel;
    StoredExp: TComboBox;
    CreateBox: TCheckBox;
    ClearBtn: TBitBtn;
    RGFunc: TRadioGroup;
    MethodBox: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure ListBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure MethodBoxClick(Sender: TObject);
  private
    { Private declarations }


    function getreadacc : integer;
    function getwriteacc : integer;
   Function GetFuncType : Integer;
    procedure SavetoStream;
    procedure LoadFromStream;
    procedure checklist(astring : string; aList:  tstrings);
{    Procedure Cat(Const s : String);}


  public
    { Public declarations }
    property readacc : integer read getreadacc;
    property writeacc : integer read getwriteacc;
    Property FuncType : Integer Read GetFuncType;

    Function MyGetVerb(Index: Integer): string;
    function MyExecuteVerb(Index: Integer) : string;

  end;

var
  PropExpert: TPropExpert;
{added 30/11/95 BI}
const
   NoneAcc = 0;
   VariableAcc = 1;
   MethodAcc = 2;

   FuncFunc = 1;
   ProcFunc = 0;


const
{added 30/11/95 BI}
      SetProperties = 0;
      ClassVerb = 1;
      BarVerb_4 = 2;
      PastePrivate = 3;
      PasteProtected = 4;
      PastePublished = 5;
      BarVerb_5 = 6;
      PasteMethods = 7;
      PasteCreateActions = 8;
      PasteDestroyActions = 9;
      BarVerb_0 = 10;
      ForLoopVars = 11;
      ForLoop = 12;
      WhileLoop = 13;
      RepeatUntil = 14;
      BarVerb_1 = 15;
      IfThenElse = 16;
      Caseofend = 17;
      WhileEnd = 18;
      BarVerb_2 = 19;
      TryFinally = 20;
      TryExcept = 21;
      BarVerb_3 = 22;
      CompilerDirVerb = 23;
      ProcedureVerb = 24;
      FunctionVerb = 25;
      barverb_6=26;
      CommentLine =27;
      Comments=28;
      barverb_7=29;
      FunctionHdr=30;
      FunctionBody=31;

      lastverb = FunctionBody;

implementation
uses
  listmain;
{$R *.DFM}
{added 30/11/95 BI}
const
  propexpstreamname : tfilename = 'c:\propexp4.ini';
  DefAcc = MethodAcc;

var

    ClassNameOld :string;
    PropertyNameOld :string;
    DataTypeOld :string;
    PrivateVarOld :string;
    ArrayIndexOld :string;
    DefaultOld :string;
    IndexOld :string;
    StoredOld :string;


Function TPropExpert.GetFuncType : Integer;
Begin
   Result := RGFunc.itemindex;
End;

function TPropExpert.getreadacc : integer;

begin
    result := rgread.itemindex;
end;

function TPropExpert.getwriteacc : integer;

begin
    result := rgwrite.itemindex;
end;

procedure TPropExpert.SavetoStream;
var
  aninifile : tinifile;
  
begin
   aninifile := tinifile.Create(propexpstreamname);
try
    writestrlist(aninifile,ClassName.items, 'Class');
    writestrlist(aninifile,PropertyName.items, 'Property');
    writestrlist(aninifile,DataType.items, 'DataType');
    writestrlist(aninifile,PrivateVar.items, 'PrivateVar');
    writestrlist(aninifile,ArrayIndex.items, 'ArrayIndex');
    writestrlist(aninifile,Defaultc.items, 'Default');
    writestrlist(aninifile,IndexEdit.items, 'Index');
    writestrlist(aninifile, StoredExp.items,'StoredExp');
finally
    aninifile.free;
end;
end;


procedure TPropExpert.LoadFromStream;
var
  aninifile : tinifile;

begin
   aninifile := tinifile.Create(propexpstreamname);
try
    readstrlist(aninifile,ClassName.items, 'Class');
    readstrlist(aninifile,PropertyName.items, 'Property');
    readstrlist(aninifile,DataType.items, 'DataType');
    readstrlist(aninifile,PrivateVar.items, 'PrivateVar');
    readstrlist(aninifile,ArrayIndex.items, 'ArrayIndex');
    readstrlist(aninifile,Defaultc.items, 'Default');
    readstrlist(aninifile,IndexEdit.items, 'Index');
    readstrlist(aninifile, StoredExp.items,'StoredExp');
finally
    aninifile.free;
end;
end;

procedure TPropExpert.checklist(astring : string; aList:  tstrings);

begin
   if (astring = '') then exit;
   if (alist.indexof(astring) = -1) then alist.add(astring);
end;

procedure TPropExpert.OKBtnClick(Sender: TObject);

begin
    with ClassName do checklist(text,items);
    with PropertyName do checklist(text,items);
    with DataType do checklist(text,items);
    with PrivateVar do checklist(text,items);
    with ArrayIndex do checklist(text,items);
    with DefaultC do checklist(text,items);
    with IndexEdit do checklist(text,items);
    with StoredExp do checklist(text,items);
    SavetoStream;
end;

procedure TPropExpert.ListBtnClick(Sender: TObject);
begin
  FrmListMaint := tFrmListMaint.create(self);
  with FrmListMaint do begin
     Try
       execute;
     Finally
       free;
     end;
  end;
end;

procedure TPropExpert.FormActivate(Sender: TObject);
begin
  LoadFromStream;
    ClassNameOld :=    ClassName.text;
    PropertyNameOld := PropertyName.text;
    DataTypeOld :=     DataType.text;
    PrivateVarOld :=   PrivateVar.text;
    ArrayIndexOld :=   ArrayIndex.text;
    DefaultOld :=      DefaultC.text;
    IndexOld :=        IndexEdit.text;
    StoredOld :=       StoredExp.text;
end;

procedure TPropExpert.CancelBtnClick(Sender: TObject);
begin
    ClassName.text := ClassNameOld ;
    PropertyName.text := PropertyNameOld ;
    DataType.text := DataTypeOld ;
    PrivateVar.text := PrivateVarOld ;
    ArrayIndex.text := ArrayIndexOld ;
    DefaultC.text := DefaultOld ;
    IndexEdit.text := IndexOld ;
    StoredExp.text := StoredOld ;
end;

procedure TPropExpert.ClearBtnClick(Sender: TObject);
begin
    ClassName.text := '';
    PropertyName.text := '';
    DataType.text := '';
    PrivateVar.text := '';
    ArrayIndex.text := '';
    DefaultC.text := '';
    IndexEdit.text := '';
    StoredExp.text := '';
    CreateBox.checked := false;
    RGRead.itemindex := DefAcc;
    RGWrite.itemindex := DefAcc;
end;

Function TPropExpert.MyGetVerb(Index: Integer): string;
Begin
   Case Index Of
      SetProperties  : Result := 'Set Properties...';
      PastePublished : Result := 'Paste P&ublished';
      PastePrivate : Result := 'Paste P&rivate';
      PasteProtected : Result := 'Paste Pro&tected';
      PasteMethods : Result := 'Paste &Method(s)';
      PasteCreateActions : Result := 'Paste &Create Actions';
      PasteDestroyActions : Result := 'Paste &Destroy Actions';
{added 30/11/95 BI}
      BarVerb_0 : Result := '-';
      BarVerb_1 : Result := '-';
      BarVerb_2 : Result := '-';
      BarVerb_3 : Result := '-';
      BarVerb_4 : Result := '-';
      BarVerb_5 : Result := '-';
      BarVerb_6 : Result := '-';
      ForLoopVars : Result := 'For Loop V&ars';
      ForLoop : Result := 'For &Loop';
      WhileLoop : Result := '&While Loop';
      RepeatUntil : Result := 'Re&peat .. Until';
      IfThenElse : Result := '&If .. Then .. Else';
      TryFinally : Result := 'Try .. Fi&nally';
      TryExcept : Result := 'Try .. &Except';
      ProcedureVerb : Result := 'Pr&ocedure';
      CompilerDirVerb : Result := 'Compiler Directive';
      FunctionVerb : Result := '&Function';
      Caseofend : Result := 'Case ... of';
      WhileEnd: Result := 'With .. end';
      ClassVerb: Result := 'Class';
      CommentLine  : Result := 'Comment Line';
      Comments : Result := 'Comment';
      barverb_7 : Result := '-';
      FunctionHdr : Result := 'Func &Header';
      FunctionBody : Result := 'Func &Body';

   End;
End;

function TPropExpert.MyExecuteVerb(Index: Integer) : string;
var
  tstr : string;

    Procedure Cat(s : String);
    Begin
      result := result + s;
    End;

Begin
   result := '';
   tstr := '';
   Case Index Of
SetProperties : ShowModal;
PastePublished : Begin
                  Cat('   Property ' + PropertyName.Text);
                  If ArrayIndex.Text <> '' Then Cat('[' + ArrayIndex.Text + ']');
                  Cat(' : ' + DataType.Text);
                  case readacc of
                      {NoneAcc}
                      VariableAcc : Cat(' Read f' + PropertyName.Text);
                      MethodAcc : Cat(' Read Get' + PropertyName.Text);
                  end;
                  case writeacc of
                      VariableAcc : Cat(' Write f' + PropertyName.Text);
                      MethodAcc : Cat(' Write Set' + PropertyName.Text);
                  end;
                  If IndexEdit.Text <> '' Then  Cat(' Index ' + IndexEdit.Text);
                  If DefaultC.Text <> '' Then  Cat(' Default ' + DefaultC.Text);
                  If StoredExp.Text <> '' Then  Cat(' Stored (' + StoredExp.Text+')');
                  Cat(';' + #13#10);
               End;
 PastePrivate  : Begin
                  if ((readacc = VariableAcc) or (writeacc = VariableAcc)) then
                    Cat('   f' + PropertyName.Text + ' : ' + DataType.Text + ';'#13#10);
                 End;
 PasteProtected : Begin
                    IF (readacc = MethodAcc) then Begin
                         Cat('   Function Get' + PropertyName.Text);
                         if ((IndexEdit.Text <> '' ) or (ArrayIndex.Text <> '')) then cat('(');
                         If IndexEdit.Text <> '' Then begin
                           Cat('Index : Integer');
                           If ArrayIndex.Text <> '' Then Cat('; ');
                         end;
                         If ArrayIndex.Text <> '' Then Cat(ArrayIndex.Text + ' : Integer');
                         if ((IndexEdit.Text <> '' ) or (ArrayIndex.Text <> '')) then cat(')');
                         Cat(' : ' + DataType.Text + ';' + #13#10);
                    End;
                    IF (writeacc = MethodAcc) then Begin
                         Cat('   Procedure Set' + PropertyName.Text + '(');
                         If IndexEdit.Text <> '' Then Cat('Index : Integer; ');
                         If ArrayIndex.Text <> '' Then Cat(ArrayIndex.Text + ' : Integer; ');
                         Cat('A' + PropertyName.Text + ' : ' + DataType.Text + ');' + #13#10);
                    End;
                 End;
FunctionHdr : if (MethodBox.checked) then  Begin
                    IF (FuncType = FuncFunc) then Begin
                         Cat(#9'Function ' + PropertyName.Text+' : '+ DataType.Text+';'+ #13#10);
                    End;
                    IF (FuncType = ProcFunc) then Begin
                         Cat(#9'Procedure ' + PropertyName.Text+';'+ #13#10);
                    End;
                 End;
FunctionBody :if (MethodBox.checked) then  Begin
                    IF (FuncType = FuncFunc) then Begin
                       Cat(#13#10'Function ' + ClassName.Text + '.' + PropertyName.Text+' : '+ DataType.Text+';'+ #13#10);
                       Cat('Begin'#13#10'   Result := X;'#13#10'End;'#13#10);
                    End;
                    IF (FuncType = ProcFunc) then Begin
                       Cat(#13#10'Procedure '+ ClassName.Text + '.' + PropertyName.Text+';'+ #13#10);
                       Cat('Begin'#13#10#13#10'End;'#13#10);
                    End;
                 End;
PasteCreateActions  : Begin
                    if (PrivateVar.Text <> '') then tstr := PrivateVar.Text
                                               else tstr := 'f'+PropertyName.Text;
                    if (Createbox.checked) then  Cat(tstr+' := '+ DataType.Text + '.Create(self);'#13#10);
                    If DefaultC.Text <> '' Then  Cat(tstr+' := '+ DefaultC.Text+';'#13#10);
                 End;
PasteDestroyActions   : Begin
                    if (PrivateVar.Text <> '') then tstr := PrivateVar.Text
                                               else tstr := 'f'+PropertyName.Text;
                    if (Createbox.checked) then Cat(tstr+'.free;'#13#10);
                 End;
  PasteMethods : Begin
                    if (PrivateVar.Text <> '') then tstr := PrivateVar.Text
                                               else tstr := 'f'+PropertyName.Text;
                    if (readacc = MethodAcc) then Begin
                       Cat(#13#10'Function ' + ClassName.Text + '.Get' + PropertyName.Text);
                       If IndexEdit.Text <> '' Then Cat('(Index : Integer)');
                       If ArrayIndex.Text <> '' Then Cat('(' + ArrayIndex.Text + ')');
                       Cat(' : ' + DataType.Text + ';'#13#10);
                       Cat('Begin'#13#10'   Result := '+ tstr + ';'#13#10'End;'#13#10);
                    end;
                    if (writeacc  = MethodAcc) then Begin
                       Cat(#13#10'Procedure '+ClassName.Text+'.Set'+PropertyName.Text+'(');
                       If (IndexEdit.Text <> '') Then Cat('Index : Integer; ');
                       If (ArrayIndex.Text <> '') Then Cat(ArrayIndex.Text+'; ');
                       Cat('A'+PropertyName.Text+' : '+DataType.Text+');'+#13#10);
                       Cat('Begin'#13#10'   If (A'+PropertyName.Text+' <> '+tstr+') then begin'#13#10);
                       Cat('         '+tstr+' := A'+PropertyName.Text + ';'#13#10'      end;'#13#10'End;'#13#10);
                    end;
                 End;
         ForLoopVars : Cat('Var'#13#10'   lc, mc : integer;'#13#10'astr, bstr : string;'#13#10'tb : boolean;'#13#10);
             ForLoop : Cat('   mc := pred(X.count);'#13#10'   for lc := 0 to mc do begin'#13#10#13#10'   end;'#13#10);
          WhileLoop  : Cat('   while (X) do begin'#13#10#13#10'   end;'#13#10);
         RepeatUntil : Cat('   repeat'#13#10#13#10'     done := X;'#13#10'   until done;'#13#10);
          IFthenelse : Cat('   if (X) then begin'#13#10#13#10'   end'#13#10'   else begin'#13#10#13#10'   end;'#13#10);
          TryFinally : Cat('   Try'#13#10#13#10'   Finally'#13#10#13#10'   end;'#13#10);
           TryExcept : Cat('   Try'#13#10#13#10'   Except'#13#10#13#10'   end;'#13#10);
       ProcedureVerb : Cat(#13#10'Procedure BlaBla(X : Y);'#13#10#13#10'begin'#13#10#13#10'end;'#13#10);
     CompilerDirVerb : Cat(#13#10'{$ifdef win32}'#13#10#13#10'{$else}'#13#10#13#10'{$endif}'#13#10);
        FunctionVerb : Cat(#13#10'Function BlaBla(X : Y) : Y;'#13#10#13#10'begin'#13#10'   result := Z;'#13#10'end;'#13#10);
           Caseofend : Cat(#13#10'   Case X of'#13#10'   1 : begin'#13#10#13#10'       end;'#13#10
                          +'   2 : begin'#13#10#13#10'       end;'#13#10'     else'#13#10#13#10'     end;'#13#10'   end;'#13#10);
           WhileEnd  : Cat('   With (X) do begin'#13#10#13#10'   end;'#13#10);
        CommentLine  : Cat(#13#10'{-=**=--=**=--=**=--=**=--=**=--=**=--=**=--=**=--=**=--=**=--=**=--=**=--=**=--=**=--=**=-}'#13#10);
            Comments : Cat('{Methods for '+ClassName.Text+#13#10#13#10'Property'+PropertyName.Text+#13#10#13#10' }');
          ClassVerb  : begin
                          Cat(#13#10+ClassName.Text + ' = class(X)'#13#10' Private'#13#10#13#10
                             +' Protected'#13#10#13#10' Public'#13#10#13#10);
                          Cat('   Constructor Create(aowner : tcomponent); Override;'#13#10
                             +'   Destructor Destroy; Override;'#13#10#13#10
                             +' Published'#13#10#13#10'end;');
                          Cat(#13#10#13#10#13#10'Constructor '+ClassName.Text+'.Create(aowner : tcomponent);'#13#10#13#10
                               +'begin'#13#10'  inherited create(aowner);'#13#10#13#10'end;'#13#10);
                          Cat(#13#10'Destructor '+ClassName.Text+'.Destroy; '#13#10#13#10
                               +'begin'#13#10#13#10'  inherited destroy;'#13#10'end;'#13#10);
                        end;

   End;
End;


procedure TPropExpert.MethodBoxClick(Sender: TObject);
begin
  RGFunc.enabled := MethodBox.checked;
end;

end.

